<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelResult extends AbstractStructArrayBase
{
    /**
     * The HotelResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelResult[]
     */
    public $HotelResult;
    /**
     * Constructor method for ArrayOfJP_HotelResult
     * @uses ArrayOfJP_HotelResult::setHotelResult()
     * @param \StructType\JP_HotelResult[] $hotelResult
     */
    public function __construct(array $hotelResult = array())
    {
        $this
            ->setHotelResult($hotelResult);
    }
    /**
     * Get HotelResult value
     * @return \StructType\JP_HotelResult[]|null
     */
    public function getHotelResult()
    {
        return $this->HotelResult;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelResultForArrayConstraintsFromSetHotelResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_HotelResultHotelResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelResultHotelResultItem instanceof \StructType\JP_HotelResult) {
                $invalidValues[] = is_object($arrayOfJP_HotelResultHotelResultItem) ? get_class($arrayOfJP_HotelResultHotelResultItem) : sprintf('%s(%s)', gettype($arrayOfJP_HotelResultHotelResultItem), var_export($arrayOfJP_HotelResultHotelResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelResult property can only contain items of type \StructType\JP_HotelResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelResult value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelResult[] $hotelResult
     * @return \ArrayType\ArrayOfJP_HotelResult
     */
    public function setHotelResult(array $hotelResult = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelResultArrayErrorMessage = self::validateHotelResultForArrayConstraintsFromSetHotelResult($hotelResult))) {
            throw new \InvalidArgumentException($hotelResultArrayErrorMessage, __LINE__);
        }
        $this->HotelResult = $hotelResult;
        return $this;
    }
    /**
     * Add item to HotelResult value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelResult $item
     * @return \ArrayType\ArrayOfJP_HotelResult
     */
    public function addToHotelResult(\StructType\JP_HotelResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelResult) {
            throw new \InvalidArgumentException(sprintf('The HotelResult property can only contain items of type \StructType\JP_HotelResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelResult
     */
    public function getAttributeName()
    {
        return 'HotelResult';
    }
}
